/******************************************************************************
**
** FILE NAME    : dwc_otg_cil_ifx.h
** PROJECT      : Twinpass/Danube
** MODULES      : DWC OTG USB
**
** DATE         : 07 Sep. 2007
** AUTHOR       : Sung Winder
** DESCRIPTION  : Default param value.
** COPYRIGHT    :       Copyright (c) 2007
**                      Infineon Technologies AG
**                      2F, No.2, Li-Hsin Rd., Hsinchu Science Park,
**                      Hsin-chu City, 300 Taiwan.
**
**    This program is free software; you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation; either version 2 of the License, or
**    (at your option) any later version.
**
** HISTORY
** $Date          $Author         $Comment
** 12 April 2007   Sung Winder     Initiate Version
*******************************************************************************/
#if !defined(__DWC_OTG_CIL_IFX_H__)
#define __DWC_OTG_CIL_IFX_H__

/* ================ Default param value ================== */
#ifdef LINUX26
#define dwc_param_opt_default 1
#define dwc_param_otg_cap_default DWC_OTG_CAP_PARAM_NO_HNP_SRP_CAPABLE
#define dwc_param_dma_enable_default 1
#define dwc_param_dma_burst_size_default 32
#define dwc_param_speed_default DWC_SPEED_PARAM_HIGH
#define dwc_param_host_support_fs_ls_low_power_default 0
#define dwc_param_host_ls_low_power_phy_clk_default DWC_HOST_LS_LOW_POWER_PHY_CLK_PARAM_48MHZ
#define dwc_param_enable_dynamic_fifo_default 1
#define dwc_param_data_fifo_size_default 2048
#define dwc_param_dev_rx_fifo_size_default 1024
#define dwc_param_dev_nperio_tx_fifo_size_default 1024
#define dwc_param_dev_perio_tx_fifo_size_default 768
#if defined(CONFIG_AMAZON_SE)
#define dwc_param_host_rx_fifo_size_default 240
#define dwc_param_host_nperio_tx_fifo_size_default 240
#define dwc_param_host_perio_tx_fifo_size_default 32
#elif defined(CONFIG_TWINPASS) || defined(CONFIG_DANUBE)
#define dwc_param_host_rx_fifo_size_default 640
#define dwc_param_host_nperio_tx_fifo_size_default 640
#define dwc_param_host_perio_tx_fifo_size_default 768
#endif
#define dwc_param_max_transfer_size_default 65535
#define dwc_param_max_packet_count_default 511
#define dwc_param_host_channels_default 16
#define dwc_param_dev_endpoints_default 6
#define dwc_param_phy_type_default DWC_PHY_TYPE_PARAM_UTMI
#define dwc_param_phy_utmi_width_default 16
#define dwc_param_phy_ulpi_ddr_default 0
#define dwc_param_phy_ulpi_ext_vbus_default DWC_PHY_ULPI_INTERNAL_VBUS
#define dwc_param_i2c_enable_default 0
#define dwc_param_ulpi_fs_ls_default 0
#define dwc_param_ts_dline_default 0

#else // for linux-2.4
/* Winder: default is for Infineon Danube/Twinpass system.
 * If other platform need to use USB, please pass modules param.
 */	
static unsigned long dwc_param_opt = 1;
static unsigned long dwc_param_otg_cap = 2;
static unsigned long dwc_param_dma_enable = 1;
static unsigned long dwc_param_dma_burst_size = 32;
static unsigned long dwc_param_speed = 0;
static unsigned long dwc_param_host_support_fs_ls_low_power = 0;
static unsigned long dwc_param_host_ls_low_power_phy_clk = 0;
static unsigned long dwc_param_enable_dynamic_fifo = 1;
static unsigned long dwc_param_data_fifo_size = 2048;
static unsigned long dwc_param_dev_rx_fifo_size = 1024;
static unsigned long dwc_param_dev_nperio_tx_fifo_size = 1024;
static unsigned long dwc_param_dev_perio_tx_fifo_size = 768;
#if defined(CONFIG_AMAZON_SE)
static unsigned long dwc_param_host_rx_fifo_size = 240;
static unsigned long dwc_param_host_nperio_tx_fifo_size = 240;
static unsigned long dwc_param_host_perio_tx_fifo_size = 32;
#elif defined(CONFIG_TWINPASS) || defined(CONFIG_DANUBE)
static unsigned long dwc_param_host_rx_fifo_size = 640;
static unsigned long dwc_param_host_nperio_tx_fifo_size = 640;
static unsigned long dwc_param_host_perio_tx_fifo_size = 768;
#endif
static unsigned long dwc_param_max_transfer_size = 65535;
static unsigned long dwc_param_max_packet_count = 511;
static unsigned long dwc_param_host_channels = 16;
static unsigned long dwc_param_dev_endpoints = 6;
static unsigned long dwc_param_phy_type = 1;
static unsigned long dwc_param_phy_utmi_width = 16;
static unsigned long dwc_param_phy_ulpi_ddr = 0;
static unsigned long dwc_param_phy_ulpi_ext_vbus = 0;
static unsigned long dwc_param_i2c_enable = 0;
static unsigned long dwc_param_ulpi_fs_ls = 0;
static unsigned long dwc_param_ts_dline = 0;

/* TODO: What is OPT mode??? */
#define dwc_param_opt_default dwc_param_opt

#define dwc_param_otg_cap_default dwc_param_otg_cap

#define dwc_param_dma_enable_default dwc_param_dma_enable

#define dwc_param_dma_burst_size_default dwc_param_dma_burst_size

#define dwc_param_speed_default dwc_param_speed

#define dwc_param_host_support_fs_ls_low_power_default dwc_param_host_support_fs_ls_low_power

#define dwc_param_host_ls_low_power_phy_clk_default dwc_param_host_ls_low_power_phy_clk

#define dwc_param_enable_dynamic_fifo_default dwc_param_enable_dynamic_fifo

/* TODO:Need to check out the exact value. */
#define dwc_param_data_fifo_size_default dwc_param_data_fifo_size

/* TODO:Need to check out the exact value. */
#define dwc_param_dev_rx_fifo_size_default dwc_param_dev_rx_fifo_size

/* TODO:Need to check out the exact value. */
#define dwc_param_dev_nperio_tx_fifo_size_default dwc_param_dev_nperio_tx_fifo_size

/* TODO:Need to check out the exact value. */
#define dwc_param_dev_perio_tx_fifo_size_default dwc_param_dev_perio_tx_fifo_size

/* TODO:Need to check out the exact value. */
#define dwc_param_host_rx_fifo_size_default dwc_param_host_rx_fifo_size

/* TODO:Need to check out the exact value. */
#define dwc_param_host_nperio_tx_fifo_size_default dwc_param_host_nperio_tx_fifo_size

/* TODO:Need to check out the exact value. */
#define dwc_param_host_perio_tx_fifo_size_default dwc_param_host_perio_tx_fifo_size

#define dwc_param_max_transfer_size_default dwc_param_max_transfer_size

#define dwc_param_max_packet_count_default dwc_param_max_packet_count

#define dwc_param_host_channels_default dwc_param_host_channels

/* TODO:Need to check out the exact value. */
#define dwc_param_dev_endpoints_default dwc_param_dev_endpoints

#define dwc_param_phy_type_default dwc_param_phy_type

#define dwc_param_phy_utmi_width_default dwc_param_phy_utmi_width

#define dwc_param_phy_ulpi_ddr_default dwc_param_phy_ulpi_ddr

#define dwc_param_phy_ulpi_ext_vbus_default dwc_param_phy_ulpi_ext_vbus

#define dwc_param_i2c_enable_default dwc_param_i2c_enable

#define dwc_param_ulpi_fs_ls_default dwc_param_ulpi_fs_ls

#define dwc_param_ts_dline_default dwc_param_ts_dline
#endif // LINUX26
/* ======================================================= */

#endif // __DWC_OTG_CIL_IFX_H__

